/* Get information from the AppBuilder

   Receives a delimited list with the parameters to adeuib/_uibinfo.p.
   First character in cprm is considered the delimiter (ex: '|').
   If the entry is "?" then the parameter is set to unknown value.   
*/
  DEFINE INPUT  PARAMETER cprm AS CHARACTER  NO-UNDO.
  
  DEFINE VARIABLE iContext AS INTEGER       NO-UNDO.
  DEFINE VARIABLE cName    AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE cRequest AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE cInfo    AS CHARACTER     NO-UNDO.
  
  DEFINE VARIABLE cTmp     AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE cDelim   AS CHARACTER     NO-UNDO.

  IF cprm = ? OR cprm = "" THEN
    RETURN "Error".
    
  cDelim = SUBSTRING(cprm, 1, 1).
  cprm = SUBSTRING(cprm, 2).
  
  IF NUM-ENTRIES(cprm, cDelim) <> 3 THEN
    RETURN "Error".
    
  cTmp     = ENTRY(1, cprm, cDelim).
  iContext = IF cTmp = "?" THEN ? ELSE INTEGER(cTmp) NO-ERROR.
  
  cTmp     = ENTRY(2, cprm, cDelim).  
  cName    = IF cTmp = "?" THEN ? ELSE cTmp.
  
  cTmp     = ENTRY(3, cprm, cDelim).  
  cRequest = IF cTmp = "?" THEN ? ELSE cTmp.
    
  RUN adeuib/_uibinfo.p (iContext, cName, cRequest, OUTPUT cInfo).
  IF RETURN-VALUE = "Error" THEN
    RETURN "Error".
  IF cInfo = ? THEN
    RETURN "?".
  RETURN cInfo.	

